﻿using EonaCat.Quic.Helpers;
using System;
using System.Collections.Generic;

namespace EonaCat.Quic.Infrastructure.Frames
{
    // This file is part of the EonaCat project(s) which is released under the Apache License.
    // See the LICENSE file or go to https://EonaCat.com/License for full license details.

    public class StreamDataBlockedFrame : Frame
    {
        public override byte Type => 0x15;
        public IntegerVar StreamId { get; set; }
        public IntegerVar MaximumStreamData { get; set; }

        public StreamDataBlockedFrame()
        {
        }

        public StreamDataBlockedFrame(ulong streamId, ulong streamDataLimit)
        {
            StreamId = streamId;
            MaximumStreamData = streamDataLimit;
        }

        public override void Decode(ByteArray array)
        {
            byte type = array.ReadByte();
            StreamId = array.ReadIntegerVar();
            MaximumStreamData = array.ReadIntegerVar();
        }

        public override byte[] Encode()
        {
            List<byte> result = new List<byte>
            {
                Type
            };
            result.AddRange(StreamId.ToByteArray());
            result.AddRange(MaximumStreamData.ToByteArray());

            return result.ToArray();
        }
    }
}