// This file is part of the EonaCat project(s) which is released under the Apache License.
// See the LICENSE file or go to https://EonaCat.com/License for full license details.

namespace EonaCat.Network
{
    /// <summary>
    /// Enumerates the possible authentication schemes in the EonaCat network library.
    /// </summary>
    public enum AuthenticationSchemes
    {
        /// <summary>
        /// No authentication scheme.
        /// </summary>
        None,

        /// <summary>
        /// Digest authentication scheme.
        /// </summary>
        Digest = 1,

        /// <summary>
        /// Basic authentication scheme.
        /// </summary>
        Basic = 8,

        /// <summary>
        /// Anonymous authentication scheme.
        /// </summary>
        Anonymous = 0x8000
    }
}