// This file is part of the EonaCat project(s) which is released under the Apache License.
// See the LICENSE file or go to https://EonaCat.com/License for full license details.

using System;

namespace EonaCat.Network
{
    /// <summary>
    /// Represents HTTP versions.
    /// </summary>
    public class HttpVersion
    {
        /// <summary>
        /// Gets the HTTP version 1.0.
        /// </summary>
        public static readonly Version Version10 = new Version(1, 0);

        /// <summary>
        /// Gets the HTTP version 1.1.
        /// </summary>
        public static readonly Version Version11 = new Version(1, 1);

        /// <summary>
        /// Initializes a new instance of the <see cref="HttpVersion"/> class.
        /// </summary>
        public HttpVersion()
        {
        }
    }
}