// This file is part of the EonaCat project(s) which is released under the Apache License.
// See the LICENSE file or go to https://EonaCat.com/License for full license details.

using System;

namespace EonaCat.Network
{
    public class CloseEventArgs : EventArgs
    {
        internal CloseEventArgs()
        {
            PayloadData = PayloadData.Empty;
        }

        internal CloseEventArgs(ushort code)
          : this(code, null)
        {
        }

        internal CloseEventArgs(CloseStatusCode code)
          : this((ushort)code, null)
        {
        }

        internal CloseEventArgs(PayloadData payloadData)
        {
            PayloadData = payloadData;
        }

        internal CloseEventArgs(ushort code, string reason)
        {
            PayloadData = new PayloadData(code, reason);
        }

        internal CloseEventArgs(CloseStatusCode code, string reason)
          : this((ushort)code, reason)
        {
        }

        internal PayloadData PayloadData { get; }

        public ushort Code => PayloadData.Code;

        public string Reason => PayloadData.Reason ?? string.Empty;

        public bool WasClean { get; internal set; }
    }
}