﻿using EonaCat.Json.Converters;
using System.Runtime.Serialization;

namespace EonaCat.Network
{
    // This file is part of the EonaCat project(s) which is released under the Apache License.
    // See the LICENSE file or go to https://EonaCat.com/License for full license details.

    /// <summary>
    /// Access control mode of operation.
    /// </summary>
    [Json.Converter(typeof(StringEnumConverter))]
    public enum AccessControlMode
    {
        /// <summary>
        /// Permit requests from any endpoint by default.
        /// </summary>
        [EnumMember(Value = "DefaultPermit")]
        DefaultPermit,

        /// <summary>
        /// Deny requests from any endpoint by default.
        /// </summary>
        [EnumMember(Value = "DefaultDeny")]
        DefaultDeny
    }
}